// Pain Pack v.1
// Its a little confusing in this file, but all yo should have to edit is the custom messages section, but you are welcome
// to change more. Just if you do, it would be nice if you would tell me what improvements you made (Arek5942@cs.com)

//*  INSTALLATION::
//
//	* In the Tribes > Config folder make a new folder and name it PAIN
//	* Extract all files into the PAIN folder
//	* In the Tribes > Config locate the autoexec.cs file and open it with notepad
//	* At the end of the file, add a new line and write:
//			Include("Pain\\Pain_Packv1.cs");
//	* Run (Re-Start) Tribes and if you see a Pain_Pack banner on the first page, it means that the 
//	  script installed correctly. Enjoy.

echo("<::> LOADING ...  PAIN_Pack v.1");
/////////////////////////////////CUSTOM MESSAGES//////////////////////////////////////////////////////////////////////////
									 	//For NOT X-pack 3001 users use:
$GeneratorOfflineMessage = " [POWER SYSTEMS OFFLINE] ~wmiscgensoffline"; 	// ~wneedrep
$GeneratorOnlineMessage = " [POWER SYSTEMS BACK ONLINE] ~wmiscpoweronline";	// ~wfwatchsh
$GeneratorEnemyOut = " [ENEMY GENERATOR DESTROYED] ~wgendes";			// ~wfwatchsh

$TenSecAnnounce = "10 seconds left. Get ready !!!~wbbrumble";
$ZeroSecAnnounce = "It's WAR time !!!~waoeatak";

$MyObjectiveMessage = "I just got five points for capturing the objective tower for our team :)~wcheer";

///////////////////////////////// On/Off SCRIPTS /////////////////////////////////////////////////////////////////////////

$RepairingTrue = 1;		// change 1 to 0 if you dont want to announce repairing

$ThankRepairingTrue = 1;	// change 1 to 0 if you dont want to thank for repairing

$DropRepPackTrue = 1; 		// change 1 to 0 if you dont want to drop rep pack at inv station

$NotPoweredTrue = 1;		// change 1 to 0 if you dont want to announce when your teams power is out

$EnemyGenOutTrue = 1;		// change 1 to 0 if you dont want to announce destroying enemy generator

$TurretInformTrue = 1;		// change 1 to 0 if you dont want to see a message when you destroy a turret

// Preference that is set otiginally to FALSE state for some weird unknown reason, that smoothes out
// the transitions between the animations if the players.
  $pref::animateWithTransitions = True;

/////////////////////////////////CUSTOM MESSAGES//////////////////////////////////////////////////////////////////////////

echo("<::> Repairing is " @ $RepairingTrue);
echo("<::> Thank Repairing is " @ $ThankRepairingTrue);
echo("<::> Droping repair pack is " @ $DropRepPackTrue);
echo("<::> Announcing power down is " @ $NotPoweredTrue);
echo("<::> Announcing Destroying enemy generator is " @ $EnemyGenOutTrue);
echo("<::> Turret information is " @ $TurretInformTrue);
echo("<::> Smooth player animation is " @ $pref::animateWithTransitions);
echo("<::> PAIN_Pack v.1 LOADING COMPLETE");

Presto::AddScriptBanner(PainHUD, "<jc><f2>-- PAIN PACK <f2>v.1 <f2>-- \n|#|                         |#|\n<f3> Includes the following: \n<jc><f4> -Announce: <f1><jc>Repairs\n <jc>-Generator Status\n -Capturing Objective\n <f4>-Toggles:<f1> Crouching, Fire\n <f4>-Counts Down: <f1>Duel, Mission \nDrops RepPack at inv station.");


//	Repairing - ANNOUNCE
// Announces repairing. Simple.:)
// One of the first scripts I ever made :-)
//
//	Being Repaired - ANNOUNCE
// Thanks the person that repairs you. Simple.:)
// It also thanks if somebody is repairing an object deployed by you.
//
//	Generator Status - ANNOUNCE
// Infors your team when you find out that generato is offline, online after being offline and when you are repairing it.
// It annoounces:
//	- Power offline - When you go to inv and its not powered.
//	- Repairing gen - When you repair it.
//	- Repairing solar panel - When you repair it.
//	- Repairing inventory station - When you repair it.
//	- Power online - When generator was offline and you go back to inv and is working.
//	- Enemy generator gone - When you destroy enemy generator.
// 
// NOTE :: The scripts uses X-Pack 3001 sounds, but you can customise them on your own.
//
//	Mission Start Countdown - ANNOUNCE
// Annnounces messages of your choice when the mission begins.
//
//	Objective point - ANNOUNCE
// Announces when you get a point for getting the objective for your team. Simple as it is :)
//
//	Constant Fire - ACTION
// When you press Numpad2 on yor keyboard, it will make the current weapon shoot untill you press fire button.
//
//	Toggle Crouch - ACTION
// It toggles crouching instead having to hold the crouch button.
//
//	Inventory Enter Drop Repair Pack - ITEM
// To use this script go to inventory station and wait half a secong before buying any pack.
// After you get warning message about having x seconds to use inv station, it throws three repair packs and
// one mine that covers the repair packs. It also deploys an ammo station if you are not pointing at a wall or somone else
// and you the position is in range.
//


/////////////////////////////////DONT EDIT BELOW UNLESS YOU KNOW WHAT YOU ARE DOING!//////////////////////////////////////



//Includes
Include("Presto\\Event.cs");
Include("Presto\\say.cs");
Include("Presto\\Match.cs");


//Zeros variables
$GeneratorOffline = 0;
$UnitNotPowered = 0;
$TurretNOW = 0;


//-------- Announce Repairing
Event::Attach(eventClientMessage, Repairing);

function Repairing(%client, %msg){
	if (Match::ParamString(%msg, "Repairing %p") && ($RepairingTrue == 1))
		{
		echo("<::>Pain_Pack Repairing");
		$person = Match::Result(p);
		say(1,  " [REPAIRING " @ $Person @ "] [+]~wmiscrepairing");	// ~wfwatchsh
		}
	}
//-------- Thank for being repaired
Event::Attach(eventClientMessage, BeingRepaired);

function BeingRepaired(%client, %msg){
	if (Match::ParamString(%msg, "Being repaired by %n") && ($ThankRepairingTrue == 1))
		{
		echo("<::>Pain_Pack Being Repaired");
		%name = Match::Result(n);

		Say(1, " [I'M BEING REPAIRED BY " @ %name @ "] [THANKS]~wmiscthankz");	// ~wfwatchsh

		Say::Local(yellWooHoo);
		schedule("Say::Animation(sayThanks, 3);", 0.5);
		schedule("Say::Local(yellAllright);", 1);
		}
	}

//-------- Count down for duel
function DuelCountDown(){
		echo("<::>Pain_Pack Duel Countdown");
		schedule("say(1, \"        -<( 3 )>-  count-down in process~wmusicswe1duelofthefates\");", "1.0");
		schedule("Client::centerPrint(\"<jc> -3- \",1);", "1.0");
		schedule("say(1, \"        -<( 2 )>-\");", "4.0");
		schedule("Client::centerPrint(\"<jc> -2- \",1);", "4.0");
		schedule("say(1, \"        -<( 1  )>-~wmusicbanjos\");", "7.0");
		schedule("Client::centerPrint(\"<jc> -1- \",1);", "7.0");
		schedule("say(1, \"-<(START THE DUEL !!!)>-\");", "10.0");
		schedule("Client::centerPrint(\"<jc><f1> KICK HIS ASS !!! \",1);", "10.0");
		schedule("Client::centerPrint(\"<jc><f0> KICK HIS ASS !!! \",1);", "10.5");
		schedule("Client::centerPrint(\"<jc><f1> KICK HIS ASS !!! \",1);", "11.0");
		schedule("Client::centerPrint(\"<jc><f0> KICK HIS ASS !!! \",1);", "11.5");
		schedule("Client::centerPrint(\"<jc><f1> KICK HIS ASS !!! \",1);", "12.0");
		schedule("Client::centerPrint(\"<jc><f0> KICK HIS ASS !!! \",1);", "12.5");
		schedule("Client::centerPrint(\"<jc><f1> KICK HIS ASS !!! \",1);", "13.0");
		schedule("Client::centerPrint(\"<jc><f0> KICK HIS ASS !!! \",1);", "13.5");
	}
function DuelCountDownON()
	{
	$DuelCountDownON = 1;
	echo("Duel::ON.");
	DuelCountDown();
	}

//-------- Announce generator status
Event::Attach(eventClientMessage, Generator);

function Generator(%client, %msg)
	{
	if (Match::String(%msg, "Unit is not powered") && ($NotPoweredTrue == 1))
		{
		echo("<::>Pain_Pack Generator Status");
		if ($UnitNotPOwered == 0)
			{
			say(1, $GeneratorOfflineMessage);
			$GeneratorOffline = 1;
			}
		if ($UnitNotPowered == 2)
			{
			say(1, $GeneratorOfflineMessage);
			$GeneratorOffline = 1;
			$UnitNotPowered = 0;
			}
		$UnitNotPowered = $UnitNotPowered + 1;
		}
	if (Match::String(%msg, "Station Access On"))
		{
		if ($GeneratorOffline == 1)
			{
			echo("<::>Pain_Pack Generator Status");
			say(1, $GeneratorOnlineMessage);
			$GeneratorOffline = 0;
			$UnitNotPowered = 2;
			}
		}
	if (Match::String(%msg, "You get 2 points for destroying an enemy generator!") && ($EnemyGenOutTrue == 1))
		{
		say(1, $GeneratorEnemyOut);
		echo("<::>Pain_Pack Generator Status");
		}
	}

//-------- Wish good luck to your players at beginning of the mission
Event::Attach(eventClientMessage, Match10sec);

function Match10sec(%client, %msg){
	if (Match::String(%msg, "Match starts in 10 seconds."))
		{
		echo("<::>Pain_Pack Match Start Countdown.");
		say(1, $TenSecAnnounce);
		}
	if (Match::String(%msg, "Match started."))
		{
		echo("<::>Pain_Pack Match Start Countdown.");
		say(0, $ZeroSecAnnounce);
		}
	}

//-------- Announce getting 5 points for capturing tower
Event::Attach(eventClientMessage, ObjectivePoint);

function ObjectivePoint(%client, %msg){
	if (Match::String(%msg, "*You receive 5 points for*"))
		{
		echo("<::>Pain_Pack Objective captured.");
		say(1, $MyObjectiveMessage);
		}
	}

//-------- Turns fire on
function ConstantFireON()
{
		echo("<::>Pain_Pack Match Constant fire.");
		postAction(2048, IDACTION_Fire1, -0); 
}

//-------- Toggles crouching on
function CrouchToggle()
{
	if($Crouch)
	{
		$Crouch = 0;
		echo("<::>Pain_Pack Match Crouching.");
		postAction(2048, IDACTION_CROUCH, -0); 
	}
	else
	{
		$Crouch = 1;
		postAction(2048, IDACTION_STAND, -0);
	}
}

//-------- Drops repair pack when entering inv station
Event::Attach(eventClientMessage, DropRepPack);

function DropRepPack(%client, %msg)
	{
	if (Match::String(%msg, "*You have * seconds to use this station*") && ($DropRepPackTrue == 1))
		{
		echo("<::>Pain_Pack Drop Repair Pack.");
		Buy ("Repair Pack");
		Drop ("Repair Pack");
		}
	}


//-------- Destroyed Turret
Event::Attach(eventClientMessage, PainTurret);

function PainTurret(%client, %msg){

	if (Match::String(%msg, "You get 1 point for destroying an enemy turret!") && ($TurretInformTrue == 1))
		{
		$TurretNOW = $TurretNOW + 1;
			Client::centerPrint("<jc> TURRETS DESTROYED        ::         " @ $TurretNOW,1);
     			schedule("Client::centerPrint(\"\", 1);", 3);
		}
		if (Match::String(%msg, "*Match starts in * seconds*"))
		{	
		$TurretNOW = 0;
		}
	}

//-------- Attaches 3 comands to buttons
EditActionMap("playMap.sae");

bindCommand(keyboard0, make, "numpad1", TO, "CrouchToggle();");
bindCommand(keyboard0, break, "numpad1", TO, "");

bindCommand(keyboard0, make, "numpad2", TO, "ConstantFireON();");
bindCommand(keyboard0, break, "numpad2", TO, "");

bindCommand(keyboard0, make, "numpad3", TO, "DuelCountDownON();");
bindCommand(keyboard0, break, "numpad3", TO, "");
